#include "ti86asm.inc"
#include "ti86math.inc"
#include "ti86ops.inc"
#include "ti86abs.inc"

.org _asm_exec_ram

	nop
	jp ProgStart
	.dw 0
	.dw ShellTitle

ShellTitle:
	.db "Trig Properties by Erik Curtis",0

Line1_Dimensions:
	ld a,0
	ld (_penRow),a
	ld a,48
	ld (_penCol),a
	ret

vertical_lines:
	ld b,40
	ld c,64
	ld d,40
	ld e,0
	ld h,1
	call _ILine
	ld b,69
	ld d,69
	ld h,1
	call _ILine
	ld b,98
	ld d,98
	ld h,1
	call _ILine
	ret

horizontal_lines:
	ld b,0
	ld c,57
	ld d,128
	ld e,57
	ld h,1
	call _ILine
	ld c,49
	ld e,49
	ld h,1
	call _ILine
	ld c,41
	ld e,41
	ld h,1
	call _ILine
	ld c,33
	ld e,33
	ld h,1
	call _ILine
	ld c,25
	ld e,25
	ld h,1
	call _ILine
	ld c,17
	ld e,17
	ld h,1
	call _ILine
	ld c,9
	ld e,9
	ld h,1
	call _ILine
	ret

angles:
	ld a,7
	ld (_penRow),a
	ld a,1
	ld (_penCol),a
	ld hl,table2
	call _vputs
	ld a,15
	ld (_penRow),a
	ld a,1
	ld (_penCol),a
	ld hl,table3
	call _vputs
	ld a,23
	ld (_penRow),a
	ld a,1
	ld (_penCol),a
	ld hl,table4
	call _vputs
	ld a,31
	ld (_penRow),a
	ld a,1
	ld (_penCol),a
	ld hl,table5
	call _vputs
	ld a,39
	ld (_penRow),a
	ld a,1
	ld (_penCol),a
	ld hl,table6
	call _vputs
	ld a,47
	ld (_penRow),a
	ld a,1
	ld (_penCol),a
	ld hl,table7
	call _vputs
	ld a,55
	ld (_penRow),a
	ld a,1
	ld (_penCol),a
	ld hl,table8
	call _vputs
	ret

ProgStart:

Identities:
	call _clrLCD

Id_line1:
	ld a,7
	ld (_penRow),a
	ld a,7
	ld (_penCol),a
	ld hl,strline1.1
	call _vputs
	ld a,7
	ld (_penRow),a
	ld a,70
	ld (_penCol),a
	ld hl,strline1.2
	call _vputs

Id_line2:
	ld a,14
	ld (_penRow),a
	ld a,7
	ld (_penCol),a
	ld hl,strline2.1
	call _vputs
	ld a,14
	ld (_penRow),a
	ld a,70
	ld (_penCol),a
	ld hl,strline2.2
	call _vputs

Id_line3:	
	ld a,21
	ld (_penRow),a
	ld a,7
	ld (_penCol),a
	ld hl,strline3.1
	call _vputs
	ld a,21
	ld (_penRow),a
	ld a,70
	ld (_penCol),a
	ld hl,strline3.2
	call _vputs

table_info:
 call _getkey
	cp kExit
	jp z,Exit
	cp kLeft
	jp z,T_Line1
	cp kRight
	jp z,t_Line1
	jp nz,table_info

t_Line1:
	call _clrLCD
	call Line1_Dimensions
	ld hl,table1
	call _vputs
	call vertical_lines
	call horizontal_lines
	call angles

t_Line2:
	ld a,7
	ld (_penRow),a
	ld a,53
	ld (_penCol),a
	ld a,48
	call _vputmap
	ld a,82
	ld (_penCol),a
	ld a,49
	call _vputmap
	ld a,112
	ld (_penCol),a
	ld a,48
	call _vputmap

t_Line3:
	ld a,15
	ld (_penRow),a
	ld a,53
	ld (_penCol),a
	ld a,49
	call _vputmap
	ld a,82
	ld (_penCol),a
	ld a,48
	call _vputmap
	ld a,105
	ld (_penCol),a
	ld hl,undefined
	call _vputs

t_Line4:
	ld a,23
	ld (_penRow),a
	ld a,53
	ld (_penCol),a
	ld a,48
	call _vputmap
	ld a,78
	ld (_penCol),a
	ld a,45
	call _vputmap
	ld a,49
	call _vputmap
	ld a,112
	ld (_penCol),a
	ld a,48
	call _vputmap

t_Line5:
	ld a,31
	ld (_penRow),a
	ld a,50
	ld (_penCol),a
	ld a,45
	call _vputmap
	ld a,49
	call _vputmap
	ld a,82
	ld (_penCol),a
	ld a,48
	call _vputmap
	ld a,105
	ld (_penCol),a
	ld hl,undefined
	call _vputs

t_Line6:
	ld a,39
	ld (_penRow),a
	ld a,50
	ld (_penCol),a
	ld a,49
	call _vputmap
	ld hl,divide2
	call _vputs
	ld a,75
	ld (_penCol),a
	ld hl,rad3
	call _vputs
	ld hl,divide2
	call _vputs
	ld a,106
	ld (_penCol),a
	ld hl,rad3
	call _vputs
	ld hl,divide3
	call _vputs

t_Line7:
	ld a,47
	ld (_penRow),a
	ld a,48
	ld (_penCol),a
	ld hl,rad2
	call _vputs
	ld hl,divide2
	call _vputs
	ld a,75
	ld (_penCol),a
	ld hl,rad2
	call _vputs
	ld hl,divide2
	call _vputs
	ld a,112
	ld (_penCol),a
	ld a,49
	call _vputmap

t_Line8:
	ld a,55
	ld (_penRow),a
	ld a,48
	ld (_penCol),a
	ld hl,rad3
	call _vputs
	ld hl,divide2
	call _vputs
	ld a,78
	ld (_penCol),a
	ld a,49
	call _vputmap
	ld hl,divide2
	call _vputs
	ld a,109
	ld (_penCol),a
	ld hl,rad3
	call _vputs

Table_info:
 call _getkey
	cp kExit
	jp z,Exit
	cp kLeft
	jp z,Identities
	cp kRight
	jp z,T_Line1
	jp nz,Table_info

T_Line1:
	call _clrLCD
	call Line1_Dimensions
	ld hl,Table1
	call _vputs
	call vertical_lines
	call horizontal_lines
	call angles

T_Line2:
	ld a,7
	ld (_penRow),a
	ld a,46
	ld (_penCol),a
	ld hl,undefined
	call _vputs
	ld a,82
	ld (_penCol),a
	ld a,49
	call _vputmap
	ld a,105
	ld (_penCol),a
	ld hl,undefined
	call _vputs

T_Line3:
	ld a,15
	ld (_penRow),a
	ld a,53
	ld (_penCol),a
	ld a,49
	call _vputmap
	ld a,75
	ld (_penCol),a
	ld hl,undefined
	call _vputs
	ld a,112
	ld (_penCol),a
	ld a,48
	call _vputmap

T_Line4:
	ld a,23
	ld (_penRow),a
	ld a,46
	ld (_penCol),a
	ld hl,undefined
	call _vputs
	ld a,78
	ld (_penCol),a
	ld a,45
	call _vputmap
	ld a,49
	call _vputmap
	ld a,105
	ld (_penCol),a
	ld hl,undefined
	call _vputs

T_Line5:
	ld a,31
	ld (_penRow),a
	ld a,50
	ld (_penCol),a
	ld a,45
	call _vputmap
	ld a,49
	call _vputmap
	ld a,75
	ld (_penCol),a
	ld hl,undefined
	call _vputs
	ld a,112
	ld (_penCol),a
	ld a,48
	call _vputmap

T_Line6:
	ld a,39
	ld (_penRow),a
	ld a,53
	ld (_penCol),a
	ld a,50
	call _vputmap
	ld a,73
	ld (_penCol),a
	ld a,50
	call _vputmap
	ld hl,rad3
	call _vputs
	ld hl,divide3
	call _vputs
	ld a,109
	ld (_penCol),a
	ld hl,rad3
	call _vputs

T_Line7:
	ld a,47
	ld (_penRow),a
	ld a,50
	ld (_penCol),a
	ld hl,rad2
	call _vputs
	ld a,78
	ld (_penCol),a
	ld hl,rad2
	call _vputs
	ld a,112
	ld (_penCol),a
	ld a,49
	call _vputmap

T_Line8:
	ld a,55
	ld (_penRow),a
	ld a,45
	ld (_penCol),a
	ld a,50
	call _vputmap
	ld hl,rad3
	call _vputs
	ld hl,divide2
	call _vputs
	ld a,82
	ld (_penCol),a
	ld a,50
	call _vputmap
	ld a,105
	ld (_penCol),a
	ld hl,rad3
	call _vputs
	ld hl,divide3
	call _vputs

Info:
 call _getkey
	cp kExit
	jp z,Exit
	cp kRight
	jp z,Identities
	cp kLeft
	jp z,t_Line1
	jp nz,Info

strline1.1:
	.db "sin ",193,"=y",0
strline1.2:
	.db "csc ",193," = 1/y,  y",LNE,"0",0
strline2.1:
	.db "cos ",193,"=x",0
strline2.2:
	.db "sec ",193," = 1/x,  y",LNE,"0",0
strline3.1:
	.db "tan ",193," = y/x,  x",LNE,"0",0
strline3.2:
	.db "cot ",193," = x/y,  y",LNE,"0",0
undefined: .db "undef.",0
table1:
	.db "sin ",193,"              cos ",193,"              tan ",193,0
Table1:
	.db "sec ",193,"              csc ",193,"              cot ",193,0
table2: .db "0",212,", ","0",0
table3: .db "90",212,", ",Lpi,"/2",0
table4: .db "180",212,", ",Lpi,0
table5: .db "270",212,", ",L3,Lpi,"/2",0
table6: .db "30",212,", ",Lpi,"/6",0
table7: .db "45",212,", ",Lpi,"/4",0
table8: .db "60",212,", ",Lpi,"/3",0
divide2: .db "/2",0
divide3: .db "/3",0
rad2: .db Lroot,L2,0
rad3: .db Lroot,L3,0

Exit:
	call _clrLCD
	ret

.end